<template>
    <div id="waitForOtherGuesses" class="container center text-center"> 
        <h3>Wait for other players guesses</h3>
        <table class="text-center center">
            <tr>
                <td>
                    <Hint v-bind:roundId="roundId"></Hint>
                </td>
                <td>
                    <Points></Points>
                </td>
                <td>
                    <ChosenCard v-bind:chosenCardId=chosenCardId></ChosenCard>
                </td>
            </tr>
        </table>
        <SelectedCardsDisplay v-bind:roundId="roundId"></SelectedCardsDisplay>
        <RemainingCards v-bind:playerId="playerId"></RemainingCards>
    </div>
</template>
<script>
    import Hint from './Hint.vue';
    import axios from 'axios';
    import ChosenCard from './ChosenCard.vue';
    import RemainingCards from './RemainingCards.vue';
    import SelectedCardsDisplay from './SelectedCardsDisplay.vue';
    import Points from './Points.vue';
    export default {
        name: 'waitForOtherGuesses',
        components: {
            ChosenCard,
            Hint,
            RemainingCards,
            SelectedCardsDisplay,
            Points
        },
        data: function () {
            return {
                chosenCardId: this.$route.params.cardId,
                playerId: this.$route.params.playerId,
                roundId: this.$route.params.roundId,
                polling: null,
                allGuessed: false
            }
        },
        methods: {
            checkIfAllGuessesDone() {
                this.polling = setInterval(() => {
                    axios.get("https://localhost:44361/api/round/" + this.roundId + "/guessesdone")
                        .then(response => this.allGuessed = response.data);
                    if (this.allGuessed) {
                        this.$router.push({ name: 'roundSummary', params: this.defineParams() });
                    }
                }, 3000);
            },
            defineParams() {
                return {
                    playerId: this.$route.params.playerId,
                    gameId: this.$route.params.gameId,
                    roundId: this.$route.params.roundId
                }
            }
        },
        beforeDestroy() {
            clearInterval(this.polling);
        },
        created: function () {
            this.checkIfAllGuessesDone();
        }
    }
</script>
<style scoped>
    .center {
  margin-left: auto;
  margin-right: auto;
    }
     td {
        padding: 20px;
    }
</style>